<?php

class Demo{

    //根据sid获取推流信息
    private function stream($sid = '' , $main = 0){
        $streams = array(
            '1234567890' => array(
                'main'      => '1',
                'rtmp'      => 'rtmp://test.domain.com/live/1234567890_main',
                'playurl'   => 'http://test.domain.com/show/1234567890'
            ),
            '1111111111' => array(
                'main'      => 0,
                'rtmp'      => 'rtmp://test.domain.com/live/1111111111',
                'playurl'   => 'http://test.domain.com/show/1111111111'
            )
        );

        if(isset($streams[$sid])){
            return $streams[$sid];
        }
        return null; 
    }

    //获得服务器时间
    public function gettime(){
        return date("Y/m/d H:i:s");//2017/03/17 10:30:59
    }

    //获取推流地址，观看地址
    public function geturl(){

        //1100　无效的设备序列号
        //1101　验证出错
        //1102　已过期(针对逾期用户).
        //1103　其它错误码

        $sid        = !empty($_REQUEST['sid'])?$_REQUEST['sid']:'';
        $stream     = !empty($_REQUEST['stream'])?$_REQUEST['stream']:'';
        $authkey    = !empty($_REQUEST['authkey'])?$_REQUEST['authkey']:'';

        //校验auth
        $authkey_b  = md5(md5(md5($sid . date('YmdH')))); //2017031710

        if ($authkey != $authkey_b) {
            //校验失败
            return 'error:1101';
        }

        $stream_obj = $this->stream($sid, $stream);
        if($stream_obj){
            if($stream_obj['main'] != ($stream == 'main')){
                //码流类型不匹配
                return 'error:1104';
            }
            return "ok:{$stream_obj['rtmp']}<br/>playurl:{$stream_obj['playurl']}";
        }else{
            //无效的设备序列号
            return 'error:1100';
        }

    }
}


//注意，此动态推流地址必须为根域名，使用http协议，如： http://api.domain.com/ 、 http://api.domain.com:8080/ 、 api.domain.com
$demo = new Demo();
$cmd = !empty($_REQUEST['cmd'])?$_REQUEST['cmd']:'index';
if(method_exists($demo,$cmd)){
    echo $demo->$cmd();
}else{
    echo '---api--';
}
